//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UnZip_u.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TZipFile *zip = new TZipFile;
//---------------------------------------------------------------------------
UnicodeString GetAStr(UnicodeString s, int no, UnicodeString id){
  s=id.SubString(1,1)+s+id.SubString(1,1);
  int a=0;
  int b=0;
  while(no>0&&b<s.Length()){
	if(id.Pos(s.SubString(b,1))>0&&id.Pos(s.SubString(b+1,1))==0) a=b+1;
	if(id.Pos(s.SubString(b,1))==0&&id.Pos(s.SubString(b+1,1))>0) no--;
   b++;
  }
  return (no>0 ? UnicodeString("") : s.SubString(a,b-a));
}
//---------------------------------------------------------------------------
int GetStrCount(UnicodeString s, UnicodeString id){
  int i;
  int c=0;
  s=id.SubString(1,1)+s+id.SubString(1,1);
  for(i=0;i<s.Length();i++)
	if(id.Pos(s.SubString(i,1))>0&&id.Pos(s.SubString(i+1,1))==0) c++;
  return c;
}
//---------------------------------------------------------------------------
void AddByPath(UnicodeString PathStr, TTreeView *ToTree){
  int i,j;
  UnicodeString CurrentPathName;
  TTreeNode *ANode;
  ToTree->Selected=NULL;
  for(i=1;i<=GetStrCount(PathStr,"\\");i++){
	CurrentPathName=GetAStr(PathStr,i,"\\");
	if(i==1){ //Find Root
	  for(j=0;j<ToTree->Items->Count;j++){
		if(ToTree->Items->Item[j]->Text==CurrentPathName){
		  ToTree->Selected=ToTree->Items->Item[j];
		  break;
		}
	  }
	  if(ToTree->Selected==NULL){
		ToTree->Selected=ToTree->Items->Add(NULL,CurrentPathName);
	  }
	}else{
	  j=0;
	  ANode=ToTree->Selected->getFirstChild();
	  while(ANode!=NULL){
		if (ANode->Text==CurrentPathName){
		  ToTree->Selected=ANode;
		  j=1;
		  break;
		}else{
		  ANode=ANode->getNextSibling();
		}
	  }
	  if (j==0){
		ToTree->Selected=ToTree->Items->AddChild(ToTree->Selected,CurrentPathName);
	  }

	}
  }
}
//---------------------------------------------------------------------------
UnicodeString GetFullPath(TTreeNode *ANode, UnicodeString Seperator){
  UnicodeString PathName="";
  TTreeNode *AParent = ANode->Parent;
  while (AParent!=NULL){
	PathName=AParent->Text+Seperator+PathName;
	AParent=AParent->Parent;
  }
  return PathName+ANode->Text;
}
//---------------------------------------------------------------------------
UnicodeString SizeStr(int size){
  UnicodeString sizestr="", s=IntToStr(size);
  for(int i=0;i<s.Length();i++){
	sizestr=((i>0)&&(i<(s.Length()-1))&&((i+1)%3==0)?UnicodeString(","):UnicodeString(""))+s[s.Length()-i]+sizestr;
  }
  return sizestr;
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::addFile(TTreeNode *SiblingNode, UnicodeString AFileName){
  UnicodeString zipFN;
  if(SiblingNode!=NULL){
	zipFN = GetFullPath(SiblingNode,"/");
	zipFN = zipFN.SubString(1,zipFN.Length()-SiblingNode->Text.Length()) + ExtractFileName(AFileName);
  }else{
	zipFN = ExtractFileName(AFileName);
  }
  if(zip->IndexOf(zipFN)>-1){
	ShowMessage("sW~--ɮפwgsb:\n\n"+zipFN);
	return;
  }
  zipFN = GetFullPath( tv->Items->Add(SiblingNode,ExtractFileName(AFileName)), "/" );
  zip->Add(AFileName,zipFN,zcDeflate);
  FChanged=true;
  MsgPanel->Font->Color = TColor(0xFF6633);
  MsgPanel->Caption = "sW " + AFileName;
  Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::addFolder(TTreeNode *SiblingNode, UnicodeString FolderPathName){
  TTreeNode *FolderNode = tv->Items->Add(SiblingNode, ExtractFileName(FolderPathName));
  TTreeNode *ANode = tv->Items->AddChild(FolderNode,".");
  TSearchRec sr;
  int found = FindFirst(FolderPathName+"\\*.*",faAnyFile,sr);
  while(found==0){
	if (sr.Name.SubString(1,1)!=".") {
	  if(sr.Attr & faDirectory){
		addFolder(ANode,FolderPathName+"\\"+sr.Name);
	  }else{
		addFile(ANode,FolderPathName+"\\"+sr.Name);
	  }
	}
	found = FindNext(sr);
  }
  FindClose(sr);
  tv->Items->Delete(ANode);
  if(!FolderNode->HasChildren){
   TBytes EmptyBytes;
   zip->Add(EmptyBytes,GetFullPath(FolderNode,"/")+"/",zcDeflate);
  }
  FChanged=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WmDropFiles(TWMDropFiles& Message)
{
  wchar_t buff[MAX_PATH];
  HDROP hDrop = (HDROP)Message.Drop;
  int numFiles = DragQueryFile(hDrop, -1, NULL, NULL);
  boolean exit = false;
  for (int i=0;i<numFiles;i++) {
	DragQueryFile(hDrop, i, buff, sizeof(buff));
	switch(zip->Mode==zmClosed){
	  case true: OpenDialog1->FileName=buff;
				 open_btnClick(this);
				 if(numFiles>1){
				   ShowMessage("@u}Ҥ@Yɮ\n\nثe}"+UnicodeString(buff));
				   exit=true;
				 }
				 break;
	  case false:if(zip->Mode==zmRead||zip->Mode==zmClosed){
				   switch(zip->Mode){
					 case zmRead:  ShowMessage("߿WҦLkקɮ");
								   break;
					 case zmClosed:ShowMessage("ثeL}ɮ");
								   break;
				   }
				   exit=true;
				   break;
				 }
				 if (DirectoryExists(buff)) {
				   addFolder(tv->Selected,buff);
				 }else{
				   addFile(tv->Selected,buff);
				 }
				 MsgPanel->Caption = "ɮ׷sW";
				 break;
	}
	if(exit) break;
  }
  DragFinish(hDrop);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdateDeleteContent(){
  UnicodeString TempZipFileName = ChangeFileExt(FZipFileName,".tmp");
  TZipFile *zx = new TZipFile;
  TZipHeader LocalHeader;
  try{
	zx->Open(TempZipFileName,zmWrite);
	for(int i=0; i<zip->FileCount; i++){
	  if(FDeleteRecord.Pos(IntToStr(i)+",")<=0){
		TStream *Stream = new TMemoryStream;
		zip->Read(i,Stream,LocalHeader);
		zx->Add(Stream,zip->FileNames[i],zcDeflate);
		Stream->Free();
		Stream = NULL;
	  }
	}
	zx->Close();
  }__finally{
	zx->Free();
  }
  if(FileExists(FZipFileName)){
	if(zip->Mode!=zmClosed) zip->Close();
	//RenameFile(FZipFileName,ChangeFileExt(FZipFileName,".bak"));
	DeleteFile(FZipFileName);
  }
  RenameFile(TempZipFileName, FZipFileName);
  FDeleteRecord = "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TForm1::ToBig5FileName(TByteDynArray FileNameArr, unsigned short FileNameLength)
{
  AnsiString Big5FN = "";
  for(int i=0;i<FileNameLength;i++){
	Big5FN += AnsiChar( FileNameArr[i] );
  }
  return Big5FN;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::open_btnClick(TObject *Sender)
{
  if(Sender==this||OpenDialog1->Execute(Handle)){
	if(FDeleteRecord!="") UpdateDeleteContent();
	if(!(zip->Mode==zmClosed)) zip->Close();
	zip->Free();
	zip = new TZipFile;
	zip->Open(OpenDialog1->FileName,zmReadWrite);
	tv->Items->Clear();
	for(int i=0;i<zip->FileCount;i++){
	  AddByPath(StringReplace(zip->FileNames[i],"/","\\",TReplaceFlags() << rfReplaceAll),tv);
	  MsgPanel->Font->Color = clGreen;
	  MsgPanel->Caption = "Ū " + zip->FileNames[i];
	  Application->ProcessMessages();
	}
	FChanged = false;
	FDeleteRecord = "";
	FZipFileName = OpenDialog1->FileName;
	MsgPanel->Caption = "Ū";
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if(FDeleteRecord!="") UpdateDeleteContent();
  if(!(zip->Mode==zmClosed)) zip->Close();
  zip->Free();
  if(FileExists(FTempSavedFile)) DeleteFile(FTempSavedFile);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ForceCurrentDirectory = true;
  FChanged = false;
  FDeleteRecord = "";
  DragAcceptFiles(this->Handle,true); //\즲\
}
//---------------------------------------------------------------------------
void __fastcall TForm1::extract_btnClick(TObject *Sender)
{
  if(tv->Selected!=NULL){
	SaveDialog1->Title = "Y...";
	SaveDialog1->FileName = tv->Selected->Text;
	if (SaveDialog1->Execute(Handle)) {
	  if(tv->Selected->HasChildren){
		TTreeNode *StopNode = tv->Selected->getNextSibling();
		TTreeNode *ANode = tv->Selected;
		while ((ANode!=NULL)&&(ANode!=StopNode)){
		  if(zip->IndexOf(GetFullPath(ANode,"/"))>=0){
			UnicodeString FilePath = GetFullPath(ANode,"\\");
			int i = FilePath.Pos(tv->Selected->Text);
			FilePath = ExtractFilePath(SaveDialog1->FileName) + FilePath.SubString(i,FilePath.Length()-i+1);
			FilePath = ExtractFilePath(FilePath);
			ForceDirectories(FilePath);
			zip->Extract(GetFullPath(ANode,"/"),FilePath,false);
		  }
		  ANode=ANode->GetNext();
		}
	  }else{
		if(zip->IndexOf(GetFullPath(tv->Selected,"/")+"/")>=0){ //ȬŸƧ
		  ForceDirectories(ExtractFilePath(SaveDialog1->FileName) + GetFullPath(tv->Selected,"\\"));
		}else{ //@ɮ
		  zip->Extract(GetFullPath(tv->Selected,"/"),ExtractFilePath(SaveDialog1->FileName),false);
		}
	  }
	}
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::new_btnClick(TObject *Sender)
{
  SaveDialog1->Title = "sYɦW";
  SaveDialog1->DefaultExt = "zip";
  if(SaveDialog1->Execute(Handle)){
	if(!(zip->Mode==zmClosed)){
	  if(FDeleteRecord!="") UpdateDeleteContent();
	  zip->Close();
	  zip->Free();
	  zip = new TZipFile;
	  FChanged = false;
	}
	tv->Items->Clear();
	zip->Open(SaveDialog1->FileName,zmWrite);
	zip->Close();
	zip->Open(SaveDialog1->FileName,zmReadWrite);
  }
  SaveDialog1->DefaultExt = "";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::tvClick(TObject *Sender)
{
  if(tv->Selected!=NULL){
	MsgPanel->Caption = GetFullPath(tv->Selected,"/");
	int i=zip->IndexOf(MsgPanel->Caption);
	if(i>-1){
	  MsgPanel->Font->Color = clBlue;
	  MsgPanel->Caption = "" + MsgPanel->Caption + "    "+ SizeStr(zip->FileInfos[i].UncompressedSize) +" Bytes";
	}else{
	  MsgPanel->Font->Color = clMaroon;
	  MsgPanel->Caption = "[" + MsgPanel->Caption + "]";
	}
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::delete_btnClick(TObject *Sender)
{
  if(tv->Selected==NULL) return;
  TTreeNode *StopNode = tv->Selected->getNextSibling();
  TTreeNode *ANode = tv->Selected;
  do{
	int i = zip->IndexOf(GetFullPath(ANode,"/"));
	if( (i<0) && (zip->IndexOf(GetFullPath(ANode,"/")+"/")>=0) )
	  i = zip->IndexOf(GetFullPath(ANode,"/")+"/");
	if(i>-1){
	  FChanged = true;
	  FDeleteRecord += IntToStr(i)+",";
	}
	ANode = ANode->GetNext();
  }while(ANode!=StopNode);
  tv->Selected->Delete();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OpenAFile(TObject *Sender)
{
  if(FileExists(FTempSavedFile)) DeleteFile(FTempSavedFile);
  if((tv->Selected!=NULL)&&(!tv->Selected->HasChildren)){
	wchar_t temppath[MAX_PATH+1] = {0};
	GetTempPath(MAX_PATH, temppath);
	zip->Extract(GetFullPath(tv->Selected,"/"),temppath,false);
	FTempSavedFile = UnicodeString(temppath+tv->Selected->Text);
	ShellExecute(Handle, L"open", FTempSavedFile.c_str(), NULL, temppath, SW_SHOWNORMAL);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::extractAll_btnClick(TObject *Sender)
{
  SaveDialog1->Title = "Y...";
  SaveDialog1->FileName = "(" + ChangeFileExt(ExtractFileName(FZipFileName),"")+ ")";
  if(SaveDialog1->Execute(Handle)){
	UnicodeString  DestFolder = SaveDialog1->FileName;
	ForceDirectories(DestFolder);
	zip->ExtractAll(DestFolder);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::big5_2_utf8_btnClick(TObject *Sender)
{
  if(zip->Mode==zmClosed){
    ShowMessage("Х}ҭlZipɮ");
	return;
  }
  SaveDialog1->Title = "ഫXɮ";
  SaveDialog1->DefaultExt = "zip";
  if (SaveDialog1->Execute(Handle)) {
	if(FDeleteRecord!="") UpdateDeleteContent();
	TZipFile *z2 = new TZipFile;
	AnsiString Big5FN;
	UnicodeString Utf8FN;
	TZipHeader LocalHeader;
	try{
	  z2->Open(SaveDialog1->FileName, zmWrite);
	  for(int i=0; i<zip->FileCount; i++){
		Big5FN = ToBig5FileName(zip->FileInfo[i].FileName, zip->FileInfo[i].FileNameLength);
		Utf8FN = Big5FN;
		TStream *Stream = new TStream;
		zip->Read(i, Stream, LocalHeader);
		Stream->Position = 0;
		z2->Add(Stream, Utf8FN, zcDeflate);
		Stream->Free();
		Stream = NULL;
	  }
	  z2->Close();
	  OpenDialog1->FileName = SaveDialog1->FileName;
	  open_btnClick(this);
	}__finally{
	  z2->Free();
	}
  }
  SaveDialog1->DefaultExt = "";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MsgPanelClick(TObject *Sender)
{
  if(MsgPanel->Caption==" 2016 Chinwa Studio!"){
	ShellExecute(Handle, L"open", L"http://frog.acsite.org/chinwasoft", NULL, NULL, SW_SHOWNORMAL);
  }
}
//---------------------------------------------------------------------------

