//---------------------------------------------------------------------------

#ifndef UnZip_uH
#define UnZip_uH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <System.Zip.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.ComCtrls.hpp>
#include <shellapi.h>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TTreeView *tv;
	TPanel *ToolBar;
	TSpeedButton *open_btn;
	TOpenDialog *OpenDialog1;
	TSpeedButton *extractAll_btn;
	TSaveDialog *SaveDialog1;
	TSpeedButton *new_btn;
	TPanel *MsgPanel;
	TSpeedButton *delete_btn;
	TSpeedButton *extract_btn;
	TSpeedButton *big5_2_utf8_btn;
	void __fastcall open_btnClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall extract_btnClick(TObject *Sender);
	void __fastcall new_btnClick(TObject *Sender);
	void __fastcall tvClick(TObject *Sender);
	void __fastcall delete_btnClick(TObject *Sender);
	void __fastcall OpenAFile(TObject *Sender);
	void __fastcall extractAll_btnClick(TObject *Sender);
	void __fastcall big5_2_utf8_btnClick(TObject *Sender);
	void __fastcall MsgPanelClick(TObject *Sender);
private:	// User declarations
	boolean FChanged;
	UnicodeString FTempSavedFile, FZipFileName, FDeleteRecord;
	void __fastcall addFile(TTreeNode *SiblingNode, UnicodeString AFileName);
	void __fastcall addFolder(TTreeNode *SiblingNode, UnicodeString FolderPathName);
	void __fastcall WmDropFiles(TWMDropFiles& Message);
	void __fastcall UpdateDeleteContent();
	AnsiString __fastcall ToBig5FileName(TByteDynArray FileNameArr, unsigned short FileNameLength);
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WmDropFiles)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
